SystemOrganization addCategory: #TutorialBrowser!

GLMExamplesBrowser subclass: #TutorialExamplesBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialExamplesBrowser methodsFor: 'private' stamp: 'StephanEggermont 6/28/2012 23:16'!
exampleBrowserForPragma: each in: aClass
	^super exampleBrowserForPragma: each in: GLMBasicExamples
! !

!TutorialExamplesBrowser methodsFor: 'as yet unclassified' stamp: 'StephanEggermont 7/2/2012 15:30'!
exampleIn: composer
	composer dynamic
		title: 'Browser';
		display: [ :exampleClass :examplePragma | self exampleBrowserForPragma: examplePragma in: exampleClass ];
		act: [ :dynamic | 
				dynamic cachedPresentation presentations first panes first presentations first openTree ] 
			entitled: 'View browser tree'.
	composer smalltalkCode
		title: 'My Source code';
		act: [ :text :exampleClass :examplePragma | StandardToolSet browse: GLMBasicExamples  selector: examplePragma selector ]
			icon: GLMUIThemeExtraIcons glamorousBrowse
			entitled: 'Browse';
		smalltalkClass: [ :exampleClass | exampleClass ];
		doItReceiver: [ :exampleClass | exampleClass ];
		display: [ :exampleClass :pragma | GLMBasicExamples sourceCodeAt: pragma selector ]! !

Object subclass: #Tutorial
	instanceVariableNames: 'root'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!Tutorial class methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:16'!
browser
	^self new browser title: self title! !

!Tutorial class methodsFor: 'public' stamp: 'StephanEggermont 6/28/2012 18:33'!
open
	^self browser openOn: self new tutorial! !

!Tutorial class methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:17'!
title
	^'Tutorial'! !

!Tutorial methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 20:56'!
browser
	"self new browser openOn: GLMBasicExamples"

	| browser |
	browser := GLMTabulator new.
	browser
		column: #titles;
		column: #example span: 4.
	browser transmit
		to: #titles;
		andShow: [ :a | a tree
				display: [:b | b ];
				children: [:b | (self perform: b) children];
				format: [:title | (self perform: title) title]].
	browser transmit
		to: #example;
		from: #titles;
		andShow: [ :a | a dynamic with: [:some :selection |
				(self perform: selection ) show value: some]  ].
	^ browser! !

Object subclass: #TutorialItem
	instanceVariableNames: 'title children childClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

TutorialItem subclass: #TutorialCustom
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialCustom methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 21:07'!
presentation
	^ presentation! !

!TutorialCustom methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 21:07'!
presentation: anObject
	presentation := anObject! !

!TutorialCustom methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 21:08'!
show
	^[ :a | a custom: presentation value]! !

TutorialItem subclass: #TutorialCustomAndSource
	instanceVariableNames: 'presentation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialCustomAndSource methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 00:05'!
presentation
	^ presentation! !

!TutorialCustomAndSource methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 00:05'!
presentation: anObject
	presentation := anObject! !

!TutorialCustomAndSource methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 00:12'!
show
	^[ :a | a stackedVerticallyArrangement.
		 a custom: presentation value.
		 a text
			title: 'Source';
			display: [:each | presentation printString].
		]! !

TutorialItem subclass: #TutorialCustomAndText
	instanceVariableNames: 'text textTitle presentation smalltalkClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:57'!
presentation
	^ presentation! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:57'!
presentation: anObject
	presentation := anObject! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:40'!
show
	^[ :a |
		| tag |
		a stackedVerticallyArrangement.
		a custom: presentation value.
		self smalltalkClass
			ifNil: [ tag := a text ]
			ifNotNil: [ tag := a smalltalkCode
				smalltalkClass: self smalltalkClass ].
		tag
			title: self textTitle;
			display: self text ]! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:21'!
smalltalkClass
	^ smalltalkClass! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 11:21'!
smalltalkClass: anObject
	smalltalkClass := anObject! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:59'!
text
	^ text! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:57'!
text: anObject
	text := anObject! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:59'!
textTitle
	textTitle ifNil: [ ^'Description' ].
	^ textTitle! !

!TutorialCustomAndText methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 10:59'!
textTitle: anObject
	textTitle := anObject! !

TutorialItem subclass: #TutorialExercise
	instanceVariableNames: 'text textTitle presentation smalltalkClass assignment target'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
assignment
	^ assignment! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
assignment: anObject
	assignment := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 15:53'!
browser
	| browser |
	browser := GLMTabulator new.
	browser column: [ :c | c row: #main; row: #source ] span: 2;
		column: #assignment.
	browser transmit to: #main; andShow: [ :b |
		b custom: self presentation ].
	browser transmit to: #source; andShow: [ :b |
		| tag |
		self smalltalkClass
			ifNil: [ tag := b text ]
			ifNotNil: [ tag := b smalltalkCode
				smalltalkClass: self smalltalkClass ].
		tag
			title: self textTitle;
			display: self text ].
	browser transmit to: #assignment; andShow: [ :b |
		b text
		display: self assignment;
		format: [ :par | (Text string: title attribute: (TextFontChange font4)), (String crlf), par ] ].
	browser startOn: self target.
	^browser! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
presentation
	^ presentation! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
presentation: anObject
	presentation := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:46'!
show
	^[ :a | a custom: self browser ]! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
smalltalkClass
	^ smalltalkClass! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
smalltalkClass: anObject
	smalltalkClass := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 15:05'!
target
	^ target! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 15:05'!
target: anObject
	target := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
text
	^ text! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
text: anObject
	text := anObject! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
textTitle
	textTitle ifNil: [ ^'Description' ].
	^ textTitle! !

!TutorialExercise methodsFor: 'accessing' stamp: 'DiegoLont 6/29/2012 14:39'!
textTitle: anObject
	textTitle := anObject! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 09:18'!
childClass
	^ childClass! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/29/2012 09:18'!
childClass: anObject
	childClass := anObject! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:14'!
children
	^ children! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 20:51'!
children: anObject
	children := anObject ifNil: [children := OrderedCollection new]! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:21'!
show
	^[ :a | 
		a text 
			display: [:par | (Text string: title attribute: (TextFontChange font4)) ]].! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:14'!
title
	^ title! !

!TutorialItem methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:14'!
title: anObject
	title := anObject! !

TutorialItem subclass: #TutorialText
	instanceVariableNames: 'text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TutorialBrowser'!

!TutorialText methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 20:49'!
show
	^[ :a | 
		a text 
			display: [:par | (Text string: title attribute: (TextFontChange font4)), (String crlf), self transformedText  ]].! !

!TutorialText methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:22'!
text
	^ text! !

!TutorialText methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 17:22'!
text: anObject
	text := anObject! !

!TutorialText methodsFor: 'accessing' stamp: 'StephanEggermont 6/28/2012 20:50'!
transformedText
	|richText attributes|
	richText := Text new.
	attributes := Set new.
	richText append: text.
	^richText! !
